from qgis.PyQt.QtCore import (
  QT_TRANSLATE_NOOP
  )
from qgis.core import (
  QgsProcessing,
  QgsProcessingParameterFeatureSource,
  QgsProcessingParameterFeatureSink,
  QgsFeatureRequest
  )

from .initabstract import initabstract


class initgeompk(initabstract):
  PARAMETERS = {                  
    "INPUT": {
      "ui_func": QgsProcessingParameterFeatureSource,
      "ui_args":{
        "description": QT_TRANSLATE_NOOP("initgeompk","Input layer"),
        "types": [QgsProcessing.TypeVectorLine, QgsProcessing.TypeVectorPolygon, QgsProcessing.TypeVectorPoint]
      }
    },
    "OUTPUT": {
      "ui_func": QgsProcessingParameterFeatureSink,
      "ui_args": {
        "description": QT_TRANSLATE_NOOP("initgeompk","Road" )
      }
    }
  }
  
  def __init__(self):
    super().__init__()
    
  def initAlgorithm(self, config):
    self.initParameters()
    
  def processAlgorithm(self, parameters, context, feedback):

    self.INPUT_LAYER =  self.parameterAsSource(parameters, "INPUT", context).materialize(QgsFeatureRequest(), feedback)
          
    self.setFieldsDict(
      parameters, context, feedback, 
      self.INPUT_LAYER.fields(), False
    )
    
    # define the feature sink
    (sink, dest_id) = self.parameterAsSink(
      parameters, "OUTPUT", context, 
      self.FIELDS_INIT, 
      self.INPUT_LAYER.wkbType(), 
      self.INPUT_LAYER.sourceCrs()
    )
    
    self.resetPk()    
    self.addFeaturesToSink(sink, dest_id, self.INPUT_LAYER)
              
    return {"OUTPUT": dest_id}
  
  def createInstance(self):
    return initgeompk()


  def displayName(self):
    return self.tr("Geometry with PK")

  def group(self):
    return self.tr("Initialize features")

  def groupId(self):
    return "initfeature"

  def createInstance(self):
    return initgeompk()
